package com.sptg.iot.biz.service;

import com.baomidou.mybatisplus.mapper.Wrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.sptg.common.core.beans.ResultBean;
import com.sptg.iot.api.dto.AlarmNoticeDto;
import com.sptg.iot.api.dto.IotAlarmDto;
import com.sptg.iot.api.dto.IotDeviceDto;
import com.sptg.iot.api.dto.IotSmsSendDto;
import com.sptg.iot.api.entity.IotAlarm;
import com.sptg.iot.api.entity.IotDevice;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

/**
 * @author zwx
 * @create 2020/10/19 23:19
 */
public interface IotAlarmServiceInterface extends IService<IotAlarm> {

    public ResultBean<Page<IotAlarm>> showIotAlarmList(IotAlarmDto iotAlarmDto);

    /**
     * 功能描述:同步告警列表
     * @param iotDeviceAlarmDto
     * @return
     */
    public ResultBean<String> syncIotAlarmList(IotAlarmDto iotDeviceAlarmDto);

    /**
     * 功能描述:同步告警详情（单个）
     * @param iotAlarmDto
     * @return
     */
    public ResultBean<String> syncIotAlarmDetailOne(IotAlarmDto iotAlarmDto);

    /**
     * 功能描述:同步告警详情（批量）
     * @param iotAlarmDtoList
     * @return
     */
    public ResultBean<String> syncIotAlarmDetailBatch(List<IotAlarmDto> iotAlarmDtoList);

    /**
     * 功能描述:同步告警详情（全量）
     * @param iotAlarmDto
     * @return
     */
    public ResultBean<String> syncIotAlarmDetailAll(IotAlarmDto iotAlarmDto);


    /**
     * 根据告警id获取本地告警记录
     * @param alarmId
     * @return
     */
    public IotAlarm getIotAlarmByAlarmId(String alarmId);

    /**
     * 获取告警列表
     * @param wrapper
     * @return
     */
    public List<IotAlarm> getList(Wrapper<IotAlarm> wrapper);

    /**
     * 分页获取告警列表
     * @param iotAlarmDto
     * @return
     */
    ResultBean<Page<IotAlarm>> pagingQuery(IotAlarmDto iotAlarmDto);

    public IotAlarm getIotAlarmById(Long id);

    public ResultBean<String> alarmNotice(List<AlarmNoticeDto> alarmNoticeDtoList);

    public ResultBean<Boolean> alarmSendSms(IotSmsSendDto iotSmsSendDto);

}
